<template>
  <div class="px-10 mb-10">
    <v-card flat>
      <template v-if="headerImageSrc">
        <v-parallax height="300" :src="headerImageSrc" class="pt-10">
          <v-card-title
            v-if="titleVisibility"
            primary-title
            class="mt-10 display-2 font-weight-thin white--text"
            v-text="page.title"
          ></v-card-title>
        </v-parallax>
      </template>
      <template v-else>
        <v-card-title
          v-if="titleVisibility"
          primary-title
          class="display-2 font-weight-thin grey--text text--darken-1"
          v-text="page.title"
        ></v-card-title>
      </template>

      <v-card-text>
        <page-content :layout="page.layout || []" :content="page.content || ''"></page-content>
      </v-card-text>
    </v-card>
  </div>
</template>

<script>
export default {
  transition: {
    name: 'slide-y-transition',
    mode: 'out-in',
  },

  layout({ store }) {
    return 'default' // this.page_layout || 'default'
  },

  fetch() {
    this.loadHeaderImage()
  },

  fetchOnServer: true,

  /* async fetch() {
    const article = await fetch(`https://dev.to/api/articles/${this.$route.params.article}`).then(res => res.json())

    if (article.id && article.user.username === this.$route.params.username) {
      this.article = article
    } else {
      // set status code on server
      if (process.server) {
        this.$nuxt.context.res.statusCode = 404
      }
      throw new Error('Article not found')
    }
  }, */

  asyncData({ store, params }) {
    const { slug = '' } = params
    const page = store.state.pages.find(item => item.slug === slug)

    return { page }
  },

  data: () => ({
    headerImageSrc: null,
  }),

  validate({ params, store }) {
    const { slug = '' } = params
    return store.state.pages.some(item => item.slug === slug && item.published)
  },

  computed: {
    siteName() {
      const { site_name: name = '' } = this.$store.state.layout
      return name
    },

    titleVisibility() {
      return this.page.title_visibility || false
    },
  },

  methods: {
    async loadHeaderImage() {
      try {
        if (this.page.image_bg) {
          const src = this.page.image_bg.path
          const params = { method: 'POST', data: { src } }
          const data = await this.$api('v1').request('cockpit/image', params)

          this.headerImageSrc = data
        }
      } catch (err) {
        console.error(err)
      }
    },
  },

  head() {
    const { slug = '' } = this.$route.params
    const { title = '', description = '' } = this.page
    const titleTemplate = slug === '' || !('_id' in this.page) ? this.siteName : `%s | ${this.siteName}`

    return {
      title,
      titleTemplate,
      meta: [{ hid: 'description', name: 'description', content: description }],
    }
  },

  /* mounted() {
    clg
  } */
}
</script>
